import 'package:flutter/material.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:vudu_mojo_app/bindings/duplexBinding.dart';
import 'package:vudu_mojo_app/pages/login/loginForm.dart';
import 'package:vudu_mojo_app/pages/login/loginPage.dart';
import 'package:vudu_mojo_app/pages/page.dart' as Mojo;
import 'package:vudu_mojo_app/sharedWidgets/textButton.dart';
import '../../setup/test_locator.dart';

void main() {
  testWidgets('LoginPage should render correctly', (WidgetTester tester) async {
    setupLocator();
    //Arrange
    var onLoginSuccess = () {};
    var logoImage = 'logo.png';
    var footerImage = 'footer.png';
    var createAccountTextColor = Colors.blue;

    //Act
    Widget testableWidget = MaterialApp(
      home: LoginPage(
        logoImage: logoImage,
        onLoginSuccess: onLoginSuccess,
        footerImage: footerImage,
        createAccountTextColor: createAccountTextColor,
      ),
    );
    await tester.pumpWidget(testableWidget);

    //Assert
    expect(find.byType(Mojo.Page), findsOneWidget);
    expect(find.byType(DuplexBinding), findsOneWidget);
    expect(find.byType(Stack), findsOneWidget);
    expect(find.byType(Positioned), findsOneWidget);
    expect(find.byType(MojoTextButton), findsOneWidget);
    expect(find.byType(LoginForm), findsOneWidget);
    expect(find.byType(TextFormField), findsNWidgets(2));
  });
}
