import 'package:flutter/material.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:vudu_mojo_app/screen.dart';

Widget buildTestableWidget() {
  return MediaQuery(
      data: MediaQueryData(),
      child: MaterialApp(home: Text('', key: Key('123'))));
}

void main() {
  testWidgets('Screen widthOf method should return correct value',
      (WidgetTester tester) async {
    //Arrange
    Widget testableWidget = buildTestableWidget();
    await tester.pumpWidget(testableWidget);
    var context = tester.element(find.byKey(Key('123')));
    //Act
    var width = Screen.widthOf(50, context);
    //Assert
    expect(width, equals(400));
  });

  testWidgets('Screen heightOf method should return correct value',
      (WidgetTester tester) async {
    //Arrange
    Widget testableWidget = buildTestableWidget();
    await tester.pumpWidget(testableWidget);
    var context = tester.element(find.byKey(Key('123')));
    //Act
    var height = Screen.heightOf(50, context);
    //Assert
    expect(height, equals(300));
  });

  testWidgets('Screen width method should return correct value',
      (WidgetTester tester) async {
    //Arrange
    Widget testableWidget = buildTestableWidget();
    await tester.pumpWidget(testableWidget);
    var context = tester.element(find.byKey(Key('123')));
    //Act
    var width = Screen.width(context);
    //Assert
    expect(width, equals(800));
  });

  testWidgets('Screen height method should return correct value',
      (WidgetTester tester) async {
    //Arrange
    Widget testableWidget = buildTestableWidget();
    await tester.pumpWidget(testableWidget);
    var context = tester.element(find.byKey(Key('123')));
    //Act
    var height = Screen.height(context);
    //Assert
    expect(height, equals(600));
  });

  testWidgets('Screen paddingTop method should return correct value',
      (WidgetTester tester) async {
    //Arrange
    Widget testableWidget = buildTestableWidget();
    await tester.pumpWidget(testableWidget);
    var context = tester.element(find.byKey(Key('123')));
    //Act
    var paddingTop = Screen.paddingTop(context);
    //Assert
    expect(paddingTop, equals(0));
  });

  testWidgets('Screen paddingBottom method should return correct value',
      (WidgetTester tester) async {
    //Arrange
    Widget testableWidget = buildTestableWidget();
    await tester.pumpWidget(testableWidget);
    var context = tester.element(find.byKey(Key('123')));
    //Act
    var paddingBottom = Screen.paddingBottom(context);
    //Assert
    expect(paddingBottom, equals(0));
  });
}
